﻿Imports System.IO
Imports System.Windows.Forms
Imports Strings = Microsoft.VisualBasic ' so can use things like left( and right( for strings
Imports System.Net.Mail ' for email
Imports System.Net ' for xively
Imports System.Text

Public Class Form1
    Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer) ' for sleep statements
    Dim InPacket(0 To 2000) As Byte
    Dim OutPacket(0 To 2000) As Byte
    Dim StopServer As Boolean
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Interval = 30 ' check every 100ms
    End Sub
    Sub OpenComPort()
        Try
            SerialPort1.PortName = TextBox4.Text
            SerialPort1.BaudRate = TextBox5.Text
            SerialPort1.Parity = IO.Ports.Parity.None ' no parity
            SerialPort1.DataBits = 8 ' 8 bits
            SerialPort1.StopBits = IO.Ports.StopBits.One ' one stop bit
            'SerialPort1.ReadTimeout = 1000 ' milliseconds so times out in 1 second if no response
            SerialPort1.Open() ' open the port
            SerialPort1.DiscardInBuffer() ' clear the input buffer
            'SerialPort1.Handshake = System.IO.Ports.Handshake.RequestToSend  'handshaking on (or .None to turn off)
        Catch ex As Exception
            MsgBox("Error opening serial port - is another program using the selected COM port?")
        End Try
    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        SerialPort1.Close()
    End Sub
    Sub SendByte(ByVal c As Byte)
        OutPacket(0) = c ' send as a byte through an array
        If SerialPort1.IsOpen = True Then
            SerialPort1.Write(OutPacket, 0, 1)
        End If
    End Sub
    Sub SendString(ByVal Lineoftext As String)
        Dim i As Integer
        Try
            For i = 1 To Strings.Len(Lineoftext)
                OutPacket(0) = Strings.Asc(Strings.Mid(Lineoftext, i, 1))
                SerialPort1.Write(OutPacket, 0, 1) ' send 1 byte
                System.Windows.Forms.Application.DoEvents() ' update the display
            Next i
            'TextBox1.Text += vbCrLf ' echo not needed at 115200
            'TextBox1.Text += Lineoftext
            Label5.Text = Lineoftext
        Catch ex As Exception
            MsgBox("Serial error")
        End Try
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static OneSec As Integer ' can only have one timer as gets very confusing with three running at once
        Static TenSec As Integer
        Static OneMinute As Integer
        ' collect bytes from the serial port
        Timer1.Enabled = False ' so don't get stuck in a loop reading bytes
        CollectBytes() ' fetch bytes frequently
        OneSec += 1
        TenSec += 1
        OneMinute += 1
        If OneSec > 9 Then ' this time is 100ms
            OneSecTimer()
            OneSec = 0
        End If
        If TenSec > 99 Then
            TenSecTimer() ' do 10 sec tasks
            TenSec = 0
        End If
        If OneMinute > 599 Then
            OneMinTimer() ' do one minute tasks
            OneMinute = 0
        End If
        Timer1.Enabled = True
    End Sub
    Private Sub CollectBytes()
        Dim BytesToRead As Integer
        Dim i As Integer
        Dim c As Byte
        If SerialPort1.IsOpen = True Then
            Do
                If SerialPort1.BytesToRead = 0 Then Exit Do ' no more bytes
                BytesToRead = SerialPort1.BytesToRead
                If BytesToRead > 2000 Then BytesToRead = 2000
                SerialPort1.Read(InPacket, 0, BytesToRead) ' read in a packet
                For i = 1 To BytesToRead
                    c = InPacket(i - 1) ' don't display ascii characters over 127 - ESP8266 returns a lot of these
                    If c < 127 Then
                        TextBox1.Text += Strings.Chr(c)
                    End If
                Next
            Loop
        End If
    End Sub
    Private Sub OneSecTimer() ' happens once a second
    End Sub
    Private Sub TenSecTimer() ' happens once every 10 seconds
    End Sub
    Private Sub OneMinTimer() ' happens once a minute
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        SendByte(65)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Timer1.Enabled = True
        OpenComPort() ' open the com port 
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        TextBox1.Text = ""
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        SendString("AT" + vbCrLf)

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        SendString("AT+RST" + vbCrLf)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        SendString("AT+CIOBAUD=9600" + vbCrLf)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        SendString("AT+CWJAP=" + Chr(34) + Chr(34) + "," + Chr(34) + Chr(34) + vbCrLf)
        MsgBox("Turn power to ESP8266 off then on now")
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        SendString("AT+CWLAP" + vbCrLf)
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        SendString("AT+CWMODE=3" + vbCrLf)
    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        SendString("AT+CWJAP=" + Chr(34) + TextBox2.Text + Chr(34) + "," + Chr(34) + TextBox3.Text + Chr(34) + vbCrLf)
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        TextBox1.Select(TextBox1.TextLength, 0) ' scroll to bottom
        TextBox1.ScrollToCaret()
    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
        SendString("AT+CWJAP?" + vbCrLf)
    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click
        SendString("AT+CIPSTATUS" + vbCrLf)
    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click
        SendString("AT+CWLIF" + vbCrLf)
    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click
        SendString("AT+CIFSR" + vbCrLf)
    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click
        SendString("AT+CWQAP" + vbCrLf)
    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click
        SendString("AT+CIOBAUD=115200" + vbCrLf)
    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click
        SendString("AT+CIPSTART=4," + Chr(34) + "TCP" + Chr(34) + "," + Chr(34) + "WWW.DARKERREALMS.ORG" + Chr(34) + ",2000" + vbCrLf)
    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click
        SendString("AT+CIPMUX?" + vbCrLf)
    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click
        SendString("AT+CIPMUX=1" + vbCrLf)
    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click
        SendString("AT+CIPSERVER=1,80" + vbCrLf) ' port 80 for http, port 23 for telnet
    End Sub


    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click
        SendString("AT+CIPCLOSE=4" + vbCrLf)
    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click
        SendString("AT+CIPSTART=4," + Chr(34) + "TCP" + Chr(34) + "," + Chr(34) + "WWW.GOOGLE.COM" + Chr(34) + ",80" + vbCrLf)
    End Sub
    Private Sub Send(ByVal lineoftext As String)
        ' pass lineoftext string to send
        ' wrap up in an AT command and send to the ESP8266 module
        'http://www.instructables.com/id/Using-the-ESP8266-module/?ALLSTEPS
        Dim i As Integer
        Dim ATstring As String
        ATstring = "AT+CIPSEND=0," + Strings.Trim(Strings.Str(Strings.Len(lineoftext) + 2)) + vbCrLf
        SendString(ATstring)
        For i = 1 To 30
            Sleep(10) ' module ready to receive n+2 bytes of data - should respond with a > and could look for this
            System.Windows.Forms.Application.DoEvents()
        Next i
        SendString(lineoftext + vbCrLf)
        Sleep(300) ' wait for module to send it out
    End Sub
    Private Sub Sendln(ByVal lineoftext As String)
        Send(lineoftext + vbCrLf)
    End Sub
    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click
        Dim i As Integer
        ' serves up a tiny web page


        'Sendln("HTTP/1.1 200 OK" + vbCrLf)
        'Sendln("Content-Type: text/html")
        'Sendln("Connection: close") '  the connection will be closed after completion of the response
        ''sendln("Refresh: 5")'  // refresh the page automatically every 5 sec
        'Sendln("")
        'Sendln("<!DOCTYPE HTML>")
        'Sendln("<html>")
        'Send("Hello World")
        'Sendln("<br />")
        'Sendln("</html>")
        ' example below - he had the same problem - need to close the connection to get it to display

        Send("Hello")
        'http://mcuoneclipse.com/2014/11/30/tutorial-web-server-with-the-esp8266-wifi-module/
        Sleep(500)
        SendString("AT+CIPCLOSE=0" + vbCrLf) ' must close the connection before the browser will display it
    End Sub

    Private Sub Button24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.Click
        ' server stays on all the time. Poll the serial port manually, collect bytes, process them, serve back
        Dim Recent As String = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" ' stays 26 characters long
        Dim c As Byte
        Dim Counter As Integer
        StopServer = False
        Timer1.Enabled = False ' turn off the timer so can manually collect bytes
        ' turn on the server
        SendString("AT+CIPSERVER=1,80" + vbCrLf) ' port 80 for http, port 23 for telnet 
        Do
            If SerialPort1.BytesToRead > 0 Then
                Do
                    SerialPort1.Read(InPacket, 0, 1) ' read in one byte
                    c = InPacket(0)
                    TextBox1.Text += Strings.Chr(c) ' may not need this, mainly for debugging
                    Recent = Strings.Mid(Recent, 2) + Strings.Chr(c) ' delete one off left, add one to right
                    If Strings.Right(Recent, 3) = "GET" Then
                        'MsgBox("Get request")
                        Sleep(500) ' experiment with delays here
                        Send("Hello") ' or serve up a proper web page in html
                        Send(Strings.Str(Counter))
                        Sleep(500) ' delay before close
                        SendString("AT+CIPCLOSE=0" + vbCrLf) ' must close the connection before the browser will display it
                        Counter += 1
                    End If
                Loop Until SerialPort1.BytesToRead = 0
            End If
            Sleep(10)
            System.Windows.Forms.Application.DoEvents()
        Loop Until StopServer = True
        Timer1.Enabled = True
        MsgBox("Server stopped")
    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click
        StopServer = True
        SendString("AT+CIPSERVER=0" + vbCrLf) ' command to shut down server mode
    End Sub
End Class

